//
//  plcio.h
//
//  Created by Christoph Birk on 2013-03-20
//  Copyright 2013 Carnegie Observatories. All rights reserved.
//

/* ---------------------------------------------------------------- */

#import <Cocoa/Cocoa.h>
#import "modio.h"

/* ---------------------------------------------------------------- */

int o2d(int);

/* ---------------------------------------------------------------- */

enum plcio_errors {
  E_plcio_error=E_modbus_last+1,
  E_plcio_ioerror,
  E_plcio_last
};

#ifdef IS_PLCIO_M
const char* plcio_errors[] = { "PLCIO: error",
                               "PLCIO: I/O error",
                               "" };
#else
extern const char* plcio_errors[];
#endif

#define PLC_DELAY  0.2

/* ---------------------------------------------------------------- */

@interface PLC_IO : Modbus_IO {

}

- (int)setCoil:(int)coil Status:(int)value;
- (int)getCoil:(int)coil Status:(int*)value;

- (int)setOutput:(int)channel Value:(int)value;
- (int)getOutput:(int)channel Value:(int*)value;
- (int)getInput:(int)channel Value:(int*)value;

- (int)setValue:(int)addr Value:(int)value;
- (int)getValue:(int)addr Value:(int*)value;

- (int)set16bit:(int)addr Value:(u_short)value;
- (int)get16bit:(int)addr Value:(u_short*)value;

- (int)set32bit:(int)addr Value:(u_int)value;
- (int)get32bit:(int)addr Value:(u_int*)value;

@end

/* ---------------------------------------------------------------- */
/* ---------------------------------------------------------------- */
/* ---------------------------------------------------------------- */
