//
// Logger.h
//
// Created by Christoph Birk on 2013-04-10
// Copyright 2013 Carnegie Observatories. All rights reserved.
//

/* ---------------------------------------------------------------- */

#import <Cocoa/Cocoa.h>

/* ---------------------------------------------------------------- */

@interface Logger : NSObject <NSTableViewDataSource> {
  NSString    *p_build,*p_exec,*baseName,*logfile;
  NSString    *last_text;
  NSLock      *messageLock,*fileLock,*noticeLock;
  NSTableView *messageTable;
  NSTextField *messageField;
  NSMutableArray *mesgArray,*timeArray;
  int         mesg_head;
  BOOL        sharedPath;
}

@property (readonly,nonatomic) NSString *logfile;

- (Logger*)initWithBase:(const char*)base useShared:(BOOL)shared;
- (Logger*)initWithBase:(const char*)base;
- (BOOL)changeLogfile;
- (void)setTable:(NSTableView*)table;
- (void)setField:(NSTextField*)field;

- (void)message:(const char*)text Level:(int)level Time:(int)dt File:(BOOL)file;
- (void)message:(const char*)text Level:(int)level Time:(int)dt;
- (void)message:(const char*)text Level:(int)level File:(BOOL)file;
- (void)message:(const char*)text File:(BOOL)file;
- (void)message:(const char*)text Level:(int)level;
- (void)message:(const char*)text; 

- (void)append:(const char*)text;

@end

/* ---------------------------------------------------------------- */
/* ---------------------------------------------------------------- */
/* ---------------------------------------------------------------- */
