//
// tcpip.h
//
// Created by Christoph Birk on 2013-03-19
// Copyright 2013 Carnegie Observatories. All rights reserved.
//
 
/* ---------------------------------------------------------------- */

#import <Cocoa/Cocoa.h>

/* ---------------------------------------------------------------- */

enum tcpip_errors { E_tcpip_error=1000,
                    E_tcpip_protocol,
                    E_tcpip_hostbyname,
                    E_tcpip_socket,
                    E_tcpip_connect,
                    E_tcpip_send,E_tcpip_recv,
                    E_tcpip_nodata,
                    E_tcpip_timeout,
                    E_tcpip_open,
                    E_tcpip_lock,
                    E_tcpip_last
};

#ifdef IS_TCPIP_M
const char* tcpip_errors[] = { "TCPIP: error" ,
                               "TCPIP: unknown protocol",
                               "TCPIP: hostbyname() failed",
                               "TCPIP: opening socket failed",
                               "TCPIP: connecting to socket failed",
                               "TCPIP: writing to socket failed",
                               "TCPIP: reading from socket failed",
                               "TCPIP: no data on socket",
                               "TCPIP: timeout on socket",
                               "TCPIP: opening socket failed",
                               "TCPIP: internal locking error",                               
                               "" };
#else
extern const char* tcpip_errors[];
#endif

/* ---------------------------------------------------------------- */

@interface TCPIP_Connection : NSObject {
  char     *host;
  int      port;
  BOOL     online;
  char     terminator;
  NSRecursiveLock *lock;
  int      lock_timeout,sock_timeout;
  int      sock;
  volatile int  count;
  volatile BOOL up_and_running;
}

@property (readonly,nonatomic) BOOL online;
@property (readonly)  volatile BOOL up_and_running;

+ (int)createClientSocket:(const char*)hostname Port:(u_short)port;

- (id)initWithHost:(const char*)hstr Port:(int)pint Online:(BOOL)on;
- (int)open;
- (int)open:(int)timeout;
- (void)close;
- (BOOL)mylock:(double)timeout;
- (int)request:(const char*)cmd Response:(char*)res Max:(int)len;
- (int)command:(const char*)cmd;
- (void)shutdown;

@end

/* ---------------------------------------------------------------- */
/* ---------------------------------------------------------------- */
/* ---------------------------------------------------------------- */
