/* ---------------------------------------------------------------- */
//
// Notice.h
//
// Created by Christoph Birk on 2012-10-18
// Copyright 2012 Carnegie Observatories. All rights reserved.
//
/* ---------------------------------------------------------------- */

#import <Cocoa/Cocoa.h>

#define INCLUDE_NOTICE_H

/* ---------------------------------------------------------------- */

@interface Notice : NSWindowController <NSWindowDelegate> {
  time_t      auto_close;
  BOOL        closed;
  id          target;
  SEL         selector;
}

@property (readonly,atomic) BOOL closed;

+ (void)initialize;
+ (void)fireTimer:(NSTimer*)theTimer;

+ (Notice*)openNotice:(const char*)text Title:(const char*)title Level:(int)level
              Target:(id)object Selector:(SEL)sel;
+ (Notice*)openNotice:(const char*)text Title:(const char*)title Time:(int)wait 
                Level:(int)level;
+ (Notice*)openNotice:(const char*)text Title:(const char*)title Time:(int)wait;
+ (Notice*)openNotice:(const char*)text Title:(const char*)title;

#ifndef NDEBUG
- (void)check_me;
#endif
- (void)action_ok:(id)sender;
- (void)close;

@end

/* ---------------------------------------------------------------- */
/* ---------------------------------------------------------------- */
/* ---------------------------------------------------------------- */
