/* ---------------------------------------------------------------- */
//
// AppDelegate.h
// DCU
//
// Created by Christoph Birk on 2013-02-26
// Copyright 2013 Carnegie Observatories. All rights reserved.
//
/* ---------------------------------------------------------------- */

#import <Cocoa/Cocoa.h>

#import "DCUcontroller.h"
#import "main.h"

/* ---------------------------------------------------------------- */

@interface AppDelegate : NSObject <NSApplicationDelegate> {
  IBOutlet NSWindow      *window;      // preference/setup window
  IBOutlet NSPopUpButton *popup_telname;
  IBOutlet NSComboBox    *combo_dcuname;
  IBOutlet NSPopUpButton *popup_telstat,*popup_dcustat;
  IBOutlet NSButton      *check_engmode,*check_ffs,*check_mcal;
  IBOutlet NSWindow      *dcuWindow;
  IBOutlet DCUcontroller *dcuController;
}

@property (readonly,nonatomic) DCUcontroller *dcuController;

/* ---------------------------------------------------------------- */

- (IBAction)action_prefs:(id)sender;
- (IBAction)action_file:(id)sender;
- (IBAction)action_telname:(id)sender;
- (IBAction)action_ok:(id)sender;
- (IBAction)action_help:(id)sender;

- (NSString*)errorString:(int)err;

/* ---------------------------------------------------------------- */

@end

/* ---------------------------------------------------------------- */
/* ---------------------------------------------------------------- */
/* ---------------------------------------------------------------- */
