/* ---------------------------------------------------------------- */
//
// plcio.h
//
// Created by Christoph Birk on 2013-03-20
// Copyright 2013 Carnegie Observatories. All rights reserved.
//
/* ---------------------------------------------------------------- */

#import <Cocoa/Cocoa.h>
#import "modio.h"

/* ---------------------------------------------------------------- */

int o2d(int);

/* ---------------------------------------------------------------- */

enum plcio_error_enum {
  E_plcio_error=E_modbus_last+1,
  E_plcio_ioerror,
  E_plcio_last
};

#define PLC_DELAY  0.2

/* ---------------------------------------------------------------- */

@interface PLC_IO : Modbus_IO {

}

- (int)setCoil:(int)coil status:(int)value;
- (int)getCoil:(int)coil status:(int*)value;

- (int)setOutput:(int)channel value:(int)value;
- (int)getOutput:(int)channel value:(int*)value;
- (int)getInput:(int)channel value:(int*)value;

- (int)setValue:(int)addr value:(int)value;
- (int)getValue:(int)addr value:(int*)value;

- (int)set16bit:(int)addr value:(u_short)value;
- (int)get16bit:(int)addr value:(u_short*)value;

- (int)set32bit:(int)addr value:(u_int)value;
- (int)get32bit:(int)addr value:(u_int*)value;

@end

/* ---------------------------------------------------------------- */
/* ---------------------------------------------------------------- */
/* ---------------------------------------------------------------- */
