/* ---------------------------------------------------------------- */
//
// Logger.h
//
// Created by Christoph Birk on 2013-04-10
// Copyright 2013 Carnegie Observatories. All rights reserved.
//
/* ---------------------------------------------------------------- */

#import <Cocoa/Cocoa.h>

/* ---------------------------------------------------------------- */

enum logger_period_enum { LOGGER_WEEKLY=1,LOGGER_DAILY,LOGGER_HOURLY };

/* ---------------------------------------------------------------- */

@interface Logger : NSObject <NSTableViewDataSource> {
  NSString    *p_exec,*p_build,*p_version;
  NSString    *baseName,*logfile;
  NSString    *last_text;
  NSString    *folder;
  NSLock      *messageLock,*fileLock;
  NSTableView *messageTable;
  NSTextField *messageField;
  NSMutableArray *mesgArray,*timeArray;
  int         n_msg,mesg_head;
  BOOL        sharedPath,showUT;
  int         period,offset;
  NSTimer     *timer;
}

@property (readonly ,nonatomic) NSString *logfile;
@property (readwrite,nonatomic) BOOL showUT;
@property (readwrite,nonatomic) int offset;

- (Logger*)init;
- (Logger*)initWithBase:(const char*)base;
- (Logger*)initWithBase:(const char*)base useShared:(BOOL)shared;
- (Logger*)initWithBase:(const char*)base useShared:(BOOL)shared period:(int)in_per;
- (Logger*)initWithBase:(const char*)base useShared:(BOOL)shared period:(int)in_per folder:(const char*)sub;

- (NSString*)logfileName;
- (BOOL)changeLogfile;
- (void)setTable:(NSTableView*)table;
- (void)setField:(NSTextField*)field;
- (void)setAutoChange:(BOOL)autoChange;

- (void)message:(const char*)text Level:(int)level Time:(int)dt File:(BOOL)file Suppress:(BOOL)suppress;
- (void)message:(const char*)text Level:(int)level Time:(int)dt File:(BOOL)file;
- (void)message:(const char*)text Level:(int)level Time:(int)dt;
- (void)message:(const char*)text Level:(int)level File:(BOOL)file;
- (void)message:(const char*)text File:(BOOL)file;
- (void)message:(const char*)text Level:(int)level;
- (void)message:(const char*)text; 

- (void)append:(const char*)text;
- (void)append:(const char*)text toArray:(NSMutableArray*)array;

@end

/* ---------------------------------------------------------------- */
/* ---------------------------------------------------------------- */
/* ---------------------------------------------------------------- */
